/*
 * File: InstantMessagePrivate.h
 *  Version 4.0
 *
 *  Abstract: Private interface to the InstantMessage.framework on Leopard
 *
 *  The most useful classes are IMServiceAgent and IMServiceAgentImpl.  Use + sharedAgent to get a shared instance.
 * 
 *  This is mostly modfied output of `class-dump /System/Library/Frameworks/InstantMessage.framework/InstantMessage`
 *  of InstantMessage.framework version 4.0 (Bundle Version 578, SourceVersion 5780000)
 *  For more details: http://imlocation.wordpress.com/2007/11/01/interfacing-with-hacking-ichat-in-leopard/
 * 
 *  Created by Vincent Gable on 10/31/07.
 *  Copyright 2007 Vincent Gable. All rights reserved.
 *  http://www.vincentgable.com
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the
 * "Software"), to deal with the Software without restriction, including
 * without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to
 * permit persons to whom the Software is furnished to do so, subject to
 * the following conditions:
 * 
 * - Redistributions of source code must retain the above copyright notice,
 * this list of conditions and the following disclaimers.
 * 
 * - Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimers in the
 * documentation and/or other materials provided with the distribution.
 * 
 * - Neither the names of Suitable Systems nor the names of its
 * contributors may be used to endorse or promote products derived from
 * this Software without specific prior written permission.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
 * IN NO EVENT SHALL THE CONTRIBUTORS OR COPYRIGHT HOLDERS BE LIABLE FOR
 * ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
 * TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 * SOFTWARE OR THE USE OR OTHER DEALINGS WITH THE SOFTWARE.
 *
 * The University of Illinois/NCSA Open Source License
 * details: http://www.opensource.org/licenses/UoI-NCSA.php
 *
 */


#import <InstantMessage/IMService.h>
 
 
 @class IMLocalObject, IMRemoteObject; //interfaces for these classes are in /System/Library/Frameworks/InstantMessage.framework/Frameworks/IMUtils.framework/IMUtils
 
 @class IMServiceAgentImpl; //forward declarations
 
 @interface IMServiceAgentCenter : NSNotificationCenter
{
    id _delegate;
}

- (void)dealloc;
- (void)finalize;
- (void)setDelegate:(id)fp8;
- (id)delegate;
- (oneway void)addObserver:(id)fp8 selector:(SEL)fp12 name:(id)fp16 object:(id)fp20;
- (oneway void)removeObserver:(id)fp8 name:(id)fp12 object:(id)fp16;
- (void)_postUnpackedNotification:(id)fp8;
- (void)_postNotificationOnMainThread:(id)fp8;
- (oneway void)postNotification:(id)fp8;
- (oneway void)postNotificationName:(id)fp8 object:(id)fp12;
- (oneway void)postNotificationName:(id)fp8 object:(id)fp12 userInfo:(id)fp16;

@end
 
 @protocol FZDaemon <NSObject>
- (oneway void)autoLoginActiveAccountsIfNecessary;
- (oneway void)loginAllAccounts;
- (oneway void)logoutAllAccounts;
- (oneway void)terminate;
- (oneway void)changeMyStatus:(id)fp8;
- (oneway void)setValue:(id)fp8 ofPersistentProperty:(id)fp12;
- (oneway void)setVCCapabilities:(unsigned long long)fp8;
- (oneway void)requestCurrentAVChatInfoForListenerID:(id)fp8 responseID:(id)fp12;
- (oneway void)requestAudioReflector:(BOOL)fp8 forListenerID:(id)fp12 responseID:(id)fp16;
- (oneway void)requestVideoStillForPerson:(id)fp8 forListenerID:(id)fp12 responseID:(id)fp16;
- (oneway void)provideCurrentAVChatInfo:(id)fp8 result:(unsigned int)fp12 transactionID:(unsigned int)fp16;
- (oneway void)provideVideoStill:(id)fp8 forPerson:(id)fp12 result:(unsigned int)fp16 transactionID:(unsigned int)fp20;
- (oneway void)setAVManagerClient:(id)fp8 URLToShare:(id)fp12;
- (oneway void)contextRequest:(id)fp8 withProperties:(id)fp12 forGUID:(id)fp16;
- (oneway void)syncContexts;
- (oneway void)displayStatusText:(id)fp8;
- (oneway void)service:(id)fp8 writeServiceDefaults:(id)fp12;
- (oneway void)service:(id)fp8 setActiveAccounts:(id)fp12;
- (oneway void)service:(id)fp8 writeAccount:(id)fp12 defaults:(id)fp16;
- (oneway void)service:(id)fp8 holdBuddyUpdatesForAccount:(id)fp12;
- (oneway void)service:(id)fp8 resumeBuddyUpdatesForAccount:(id)fp12;
- (oneway void)service:(id)fp8 autoLoginWithAccount:(id)fp12;
- (oneway void)service:(id)fp8 loginWithAccount:(id)fp12;
- (oneway void)service:(id)fp8 logoutOfAccount:(id)fp12;
- (oneway void)service:(id)fp8 sessionCertificatesChangedForAccount:(id)fp12;
- (oneway void)service:(id)fp8 enableSecureIM:(BOOL)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 disableCertificatesForPerson:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 requestBuddyPicturesAndPropertiesForAccount:(id)fp12;
- (oneway void)service:(id)fp8 requestProperty:(id)fp12 ofPerson:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 setValue:(id)fp12 ofProperty:(id)fp16 ofPerson:(id)fp20 forAccount:(id)fp24;
- (oneway void)service:(id)fp8 requestGroupsForAccount:(id)fp12;
- (oneway void)service:(id)fp8 changeGroups:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 changeGroup:(id)fp12 changes:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 renameGroup:(id)fp12 to:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 createChatForIMsWith:(id)fp12 isDirect:(BOOL)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 createChatWith:(id)fp12 invitation:(id)fp16 named:(id)fp20 forAccount:(id)fp24;
- (oneway void)service:(id)fp8 goToChatNamed:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 invitePerson:(id)fp12 toChat:(id)fp16 withMessage:(id)fp20;
- (oneway void)service:(id)fp8 respond:(BOOL)fp12 toInvitationToChat:(id)fp16;
- (oneway void)service:(id)fp8 sendMessage:(id)fp12 toChat:(id)fp16;
- (oneway void)service:(id)fp8 leaveChat:(id)fp12;
- (oneway void)service:(id)fp8 setPerson:(id)fp12 isIgnored:(BOOL)fp16 inChat:(id)fp20;
- (oneway void)service:(id)fp8 requestVCWithPerson:(id)fp12 properties:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 cancelVCRequestWithPerson:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 respondToVCInvitationWithPerson:(id)fp12 properties:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 sendCounterProposalToPerson:(id)fp12 properties:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 sendVCUpdate:(id)fp12 toPerson:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 sendAVMessageToPerson:(id)fp12 sessionID:(unsigned int)fp16 type:(unsigned int)fp20 userInfo:(id)fp24 forAccount:(id)fp28;
- (oneway void)service:(id)fp8 setBlockList:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 setAllowList:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 setBlockingMode:(unsigned int)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 setBlockIdleStatus:(BOOL)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 acceptSubscriptionRequest:(BOOL)fp12 from:(id)fp16 forAccount:(id)fp20;
- (oneway void)service:(id)fp8 requestSubscriptionTo:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 startWatchingBuddy:(id)fp12 forAccount:(id)fp16;
- (oneway void)service:(id)fp8 stopWatchingBuddy:(id)fp12 forAccount:(id)fp16;
- (oneway void)addListener:(id)fp8 withListenerID:(id)fp12 forKey:(id)fp16 capabilities:(unsigned int)fp20;
- (oneway void)removeListener:(id)fp8;
@end

#pragma mark neccecary
@protocol FZDaemonListener <NSObject>
- (oneway void)services:(id)fp8 myStatus:(id)fp12 persistentProperties:(id)fp16;
- (oneway void)service:(id)fp8 properties:(id)fp12 defaults:(id)fp16 defaultAccountSettings:(id)fp20 allAccounts:(id)fp24 activeAccounts:(id)fp28;
- (oneway void)vcCapabilitiesChanged:(unsigned long long)fp8;
- (oneway void)setupComplete;
- (oneway void)defaultsChanged:(id)fp8 forService:(id)fp12;
- (oneway void)activeAccountsChanged:(id)fp8 forService:(id)fp12;
- (oneway void)account:(id)fp8 defaultsChanged:(id)fp12;
- (oneway void)account:(id)fp8 blockListChanged:(id)fp12;
- (oneway void)account:(id)fp8 allowListChanged:(id)fp12;
- (oneway void)account:(id)fp8 blockingModeChanged:(unsigned int)fp12;
- (oneway void)account:(id)fp8 blockIdleStatusChanged:(BOOL)fp12;
- (oneway void)account:(id)fp8 capabilities:(unsigned long long)fp12 serviceLoginStatus:(unsigned int)fp20 loginStatusMessage:(id)fp24;
- (oneway void)account:(id)fp8 loginStatusChanged:(unsigned int)fp12 message:(id)fp16 reason:(unsigned int)fp20 properties:(id)fp24;
- (oneway void)account:(id)fp8 capabilitiesChanged:(unsigned long long)fp12;
- (oneway void)account:(id)fp8 buddyPropertiesChanged:(id)fp12;
- (oneway void)shutdownAVForAccount:(id)fp8;
- (oneway void)account:(id)fp8 buddyPictureChanged:(id)fp12 imageData:(id)fp16 imageHash:(id)fp20;
- (oneway void)account:(id)fp8 groupsChanged:(id)fp12 error:(id)fp16;
- (oneway void)account:(id)fp8 buddyProperties:(id)fp12 buddyPictures:(id)fp16;
- (oneway void)invitedToChat:(id)fp8 isChatRoom:(BOOL)fp12 invitation:(id)fp16;
- (oneway void)account:(id)fp8 directIMRequestFrom:(id)fp12 invitation:(id)fp16;
- (oneway void)chat:(id)fp8 statusChanged:(int)fp12;
- (oneway void)chat:(id)fp8 messageReceived:(id)fp12;
- (oneway void)chat:(id)fp8 showError:(id)fp12;
- (oneway void)chat:(id)fp8 member:(id)fp12 statusChanged:(int)fp16;
- (oneway void)account:(id)fp8 invitedToVC:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 responseToVCRequest:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 cancelVCInviteFrom:(id)fp12;
- (oneway void)account:(id)fp8 counterProposalFrom:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 updateVCFrom:(id)fp12 data:(id)fp16;
- (oneway void)account:(id)fp8 handleAVMessage:(id)fp12 sessionID:(unsigned int)fp16 type:(unsigned int)fp20 userInfo:(id)fp24;
- (oneway void)account:(id)fp8 handleSubscriptionRequestFrom:(id)fp12;
- (oneway void)showInvalidCertNotificationForAccount:(id)fp8;
- (oneway void)showForgotPasswordNotificationForAccount:(id)fp8;
- (oneway void)myStatusChanged:(id)fp8;
- (oneway void)daemonPersistentProperty:(id)fp8 changedTo:(id)fp12;
- (oneway void)currentAVChatInfoRequestedWithTransactionID:(unsigned int)fp8;
- (oneway void)audioReflectorRequested:(BOOL)fp8 transactionID:(unsigned int)fp12;
- (oneway void)videoStillForPersonRequested:(id)fp8 withTransactionID:(unsigned int)fp12;
- (oneway void)currentAVChatInfoProvided:(id)fp8 result:(unsigned int)fp12 responseID:(id)fp16;
- (oneway void)videoStill:(id)fp8 providedForPerson:(id)fp12 result:(unsigned int)fp16 responseID:(id)fp20;
- (oneway void)setAVManagerRequested:(BOOL)fp8 URLToShare:(id)fp12;
- (oneway void)contextUpdate:(id)fp8;
- (oneway void)contextEndedForGUID:(id)fp8;
- (oneway void)displayStatusText:(id)fp8;
@end

@interface IMServiceAgent : NSObject
{
}

+ (oneway void)setServiceAgentCapabilities:(int)fp8;
+ (int)serviceAgentCapabilities;
+ (IMServiceAgent*) sharedAgent; //actually a IMServiceAgentImpl*
+ (id)imageURLForStatus:(unsigned int)fp8;
+ (id)imageNameForStatus:(unsigned int)fp8;
+ (oneway void)forgetStatusImageAppearance;
+ (id)notificationCenter;
- (oneway void)connectWithLaunch:(BOOL)launch;
- (id)allServices;
- (id)allServicesNonBlocking;
- (id)serviceWithName:(id)fp8;
- (id)serviceWithNameNonBlocking:(id)fp8;
- (id)notificationCenter;
- (oneway void)loginAllServices;
- (oneway void)logoutAllServices;
- (oneway void)setMyStatus:(IMPersonStatus)statusType message:(NSString*)statusMessage;
- (IMPersonStatus) myStatus; //you are better off using [IMService myStatus]
- (NSString*) myStatusMessage;
- (oneway void)setMyPictureData:(NSData*)newPictureData;
- (NSData*) myPictureData;
- (NSDate*) myIdleTime; //you are better off using [IMService myIdleTime];
- (oneway void)setMyProfile:(NSString*)profile;
- (NSString*) myProfile;
- (NSArray*) myAvailableMessages;
- (NSArray*) myAwayMessages;
- (id)preferredClientSignature;
- (id)currentAVChatInfo;
- (unsigned int)requestAudioReflectorStart;
- (unsigned int)requestAudioReflectorStop;
- (unsigned int)requestVideoStillForPerson:(id)fp8;
- (unsigned long long)vcCapabilities;
- (id)localObject;

@end

@interface IMServiceAgentImpl : IMServiceAgent <FZDaemonListener>
{
    unsigned long long _vcCapabilities;
    IMLocalObject *_localDaemonListener;
    IMRemoteObject<FZDaemon> *_remoteDaemonListener;
    NSDictionary *_services;
    IMServiceAgentCenter *_notifCenter;
    unsigned int _myStatus;
    NSString *_myStatusMessage;
    NSDate *_myIdleTime;
    NSData *_myPictureData;
    NSString *_myProfile;
    NSDictionary *_currentAVChatInfo;
    BOOL _hookingUpToDaemon;
    BOOL _hasCheckedForDaemon;
}

+ (void)_instantMessageMain;
+ (IMServiceAgentImpl*) sharedAgent;
+ (void)initialize;
+ (id) notificationCenter;
+ (void)forgetStatusImageAppearance;
+ (void)_statusImageAppearanceChanged:(id)fp8;
+ (void)_determineStatusImageAppearance;
+ (id)imageNameForStatus:(unsigned int)fp8;
+ (id)imageURLForStatus:(unsigned int)fp8;
- (id)init;
- (void)dealloc;
- (void)finalize;
- (oneway void)_connectToDaemonAndLaunch:(BOOL)fp8;
- (oneway void)connectWithLaunch:(BOOL)fp8;
- (oneway void)_disconnectFromDaemon:(BOOL)fp8;
- (void)_remoteObjectDiedNotification:(id)fp8;
- (void)remoteObjectDiedNotification:(id)fp8;
- (void)_registerForDaemonLaunchNotifications:(BOOL)fp8;
- (void)_daemonLaunchedNotification:(id)fp8;
- (void)daemonLaunchedNotification:(id)fp8;
- (id)localObject;
- (void)_blockUntilConnected;
- (oneway void)launchIfNecessary;
- (id)allServicesNonBlocking;
- (id)allServices;
- (id)serviceWithNameNonBlocking:(id)fp8;
- (id)serviceWithName:(id)fp8;
- (oneway void)centerWillAddObserver;
- (oneway void)centerDidRemoveObserver;
- (id) notificationCenter;
- (void)_customMessagesChanged:(id)fp8;
- (void)_statusImageAppearanceChanged:(id)fp8;
- (oneway void)myStatusChanged:(id)fp8;
- (oneway void)daemonPersistentProperty:(id)fp8 changedTo:(id)fp12;
- (oneway void)currentAVChatInfoRequestedWithTransactionID:(unsigned int)fp8;
- (oneway void)audioReflectorRequested:(BOOL)fp8 transactionID:(unsigned int)fp12;
- (oneway void)videoStillForPersonRequested:(id)fp8 withTransactionID:(unsigned int)fp12;
- (oneway void)currentAVChatInfoProvided:(id)fp8 result:(unsigned int)fp12 responseID:(id)fp16;
- (oneway void)videoStill:(id)fp8 providedForPerson:(id)fp12 result:(unsigned int)fp16 responseID:(id)fp20;
- (oneway void)setAVManagerRequested:(BOOL)fp8 URLToShare:(id)fp12;
- (void)_handleDaemonException:(id)fp8;
- (id)preferredClientSignature;
- (BOOL)_hasEnabledServices;
- (void)loginAllServices;
- (void)logoutAllServices;
- (void)_sendABInformationToDaemon;
- (void)_setMyStatus:(unsigned int)fp8 message:(id)fp12;
- (void)setMyStatus:(IMPersonStatus)statusType message:(NSString*)statusMessage;
- (IMPersonStatus) myStatus; //you are better off using [IMService myStatus];
- (NSString*) myStatusMessage;
- (NSData*) myPictureData;
- (void) setMyPictureData:(NSData*)newPictureData;
- (NSDate*) myIdleTime; //you are better off using [IMService myIdleTime];
- (NSString*) myProfile;
- (void) setMyProfile:(NSString*)newProfile;
- (NSArray*)myAvailableMessages;
- (NSArray*)myAwayMessages;
- (oneway void)_currentAVChatInfoProvided:(id)fp8 responseID:(id)fp12 result:(unsigned int)fp16 exception:(id)fp20;
- (oneway void)_videoStill:(id)fp8 providedForPerson:(id)fp12 responseID:(id)fp16 result:(unsigned int)fp20 exception:(id)fp24;
- (id)currentAVChatInfo;
- (oneway void)_reportAVChatInfoException:(id)fp8 responseID:(id)fp12;
- (unsigned int)_requestAudioReflector:(BOOL)fp8;
- (unsigned int)requestAudioReflectorStart;
- (unsigned int)requestAudioReflectorStop;
- (unsigned int)requestVideoStillForPerson:(id)fp8;
- (id)_firstName;
- (id)_lastName;
- (id)_email;
- (oneway void)_addressBookChanged:(id)fp8;
- (oneway void)displayStatusText:(id)fp8;
- (oneway void)contextUpdate:(id)fp8;
- (oneway void)contextEndedForGUID:(id)fp8;
- (id)serviceForUniqueID:(id)fp8;
- (oneway void)defaultsChanged:(id)fp8 forService:(id)fp12;
- (oneway void)activeAccountsChanged:(id)fp8 forService:(id)fp12;
- (oneway void)account:(id)fp8 defaultsChanged:(id)fp12;
- (oneway void)account:(id)fp8 loginStatusChanged:(unsigned int)fp12 message:(id)fp16 reason:(unsigned int)fp20 properties:(id)fp24;
- (oneway void)account:(id)fp8 capabilitiesChanged:(unsigned long long)fp12;
- (oneway void)account:(id)fp8 buddyPropertiesChanged:(id)fp12;
- (oneway void)shutdownAVForAccount:(id)fp8;
- (oneway void)account:(id)fp8 buddyPictureChanged:(id)fp12 imageData:(id)fp16 imageHash:(id)fp20;
- (oneway void)account:(id)fp8 groupsChanged:(id)fp12 error:(id)fp16;
- (oneway void)account:(id)fp8 buddyProperties:(id)fp12 buddyPictures:(id)fp16;
- (oneway void)invitedToChat:(id)fp8 isChatRoom:(BOOL)fp12 invitation:(id)fp16;
- (oneway void)account:(id)fp8 directIMRequestFrom:(id)fp12 invitation:(id)fp16;
- (oneway void)chat:(id)fp8 statusChanged:(int)fp12;
- (oneway void)chat:(id)fp8 messageReceived:(id)fp12;
- (oneway void)chat:(id)fp8 showError:(id)fp12;
- (oneway void)chat:(id)fp8 member:(id)fp12 statusChanged:(int)fp16;
- (oneway void)account:(id)fp8 invitedToVC:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 responseToVCRequest:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 cancelVCInviteFrom:(id)fp12;
- (oneway void)account:(id)fp8 counterProposalFrom:(id)fp12 properties:(id)fp16;
- (oneway void)account:(id)fp8 updateVCFrom:(id)fp12 data:(id)fp16;
- (oneway void)account:(id)fp8 handleAVMessage:(id)fp12 sessionID:(unsigned int)fp16 type:(unsigned int)fp20 userInfo:(id)fp24;
- (oneway void)account:(id)fp8 handleSubscriptionRequestFrom:(id)fp12;
- (oneway void)showInvalidCertNotificationForAccount:(id)fp8;
- (oneway void)showForgotPasswordNotificationForAccount:(id)fp8;
- (oneway void)account:(id)fp8 blockListChanged:(id)fp12;
- (oneway void)account:(id)fp8 allowListChanged:(id)fp12;
- (oneway void)account:(id)fp8 blockingModeChanged:(unsigned int)fp12;
- (oneway void)account:(id)fp8 blockIdleStatusChanged:(BOOL)fp12;
- (oneway void)account:(id)fp8 capabilities:(unsigned long long)fp12 serviceLoginStatus:(unsigned int)fp20 loginStatusMessage:(id)fp24;
- (oneway void)services:(id)fp8 myStatus:(id)fp12 persistentProperties:(id)fp16;
- (oneway void)service:(id)fp8 properties:(id)fp12 defaults:(id)fp16 defaultAccountSettings:(id)fp20 allAccounts:(id)fp24 activeAccounts:(id)fp28;
- (oneway void)setupComplete;
- (oneway void)vcCapabilitiesChanged:(unsigned long long)fp8;
- (unsigned long long)vcCapabilities;

@end
